<?php
/** @noinspection PhpDocFinalChecksInspection */

namespace jrosset\ExtendedMonolog;

use jrosset\ExceptionHelper\ExceptionHelper;
use Monolog\Level;
use Monolog\Logger;
use Throwable;

/**
 * A logger with method for managing exception directly
 */
class ExceptionLogger extends Logger implements ExceptionLoggerInterface {
    /**
     * @inheritDoc
     */
    public function exception (Level|int $level, Throwable $exception, array $context = []): void {
        $this->addRecord(
            $level,
            ExceptionHelper::toString($exception, false) . PHP_EOL,
            array_merge(
                [
                    'exception' => $exception,
                ],
                $context
            )
        );
    }
}